local file = { priority = .1 }

local function toggleFullscreen()
	lw.setFullscreen( not lw.getFullscreen() )
end

local function returnToMainMenu()
	Game.state = "mainmenu"
end

local function setResolutionScale( sliderfrac )
	local logscale = (sliderfrac-0.5)*2 -- move to middle of log, scale is +/-1 octaves at 100%/0%
	local scale = 2^logscale
	Screen:setResolutionScale( scale )
end

local function setAudioVolume( volume )
	la.setVolume( volume )
end

local function setAimSensitivity( sliderfrac )
	local logsens = (sliderfrac-0.5)*4 -- move to middle of log, scale is +/-2 octaves at 100%/0%
	local sensitivity = 2*(2^logsens) -- want 2 arcmin at center
	Controller:setAimSensitivity( sensitivity )
end

local function setToggleZoom( sliderfrac )
	-- local toggle = false
	-- if sliderfrac > 0 then toggle = true end
	-- Controller:setToggleZoom( toggle )
	Controller:setToggleZoom( sliderfrac )
end

local function setFieldOfView( sliderfrac )
	local logfocal = 2*(0.5-sliderfrac) -- flip and move to middle of log, 1x/0.5x zoom for left/rightmost
	local focal = 2^(0.5+logfocal) -- at slider center FocLen is sqrt2 of screenheight (90fov at square diagonal)
	Controller:setFocalLength( focal )

	 -- gross, shouldn't change it like this, should make an interface instead?
	g3d.camera.focal = focal
	g3d.camera.updateProjectionMatrix()
end


local x = 15
local menu = {
	state = "settings",
	
	elements = {
		MenuButton:new( toggleFullscreen,   "Fullscreen",       x,115 ),
		MenuSlider:new( setResolutionScale, "Resolution Scale", x,150, nil,nil, 1/24, 1/2 ),
		MenuSlider:new( setAudioVolume,     "Audio Volume",     x,185, nil,nil, 1/10, 1   ),
		MenuSlider:new( setAimSensitivity,  "Aim Sensitivity",  x,220, nil,nil, 1/48, 3/4 ),
		MenuSlider:new( setFieldOfView,     "Field of View",    x,255, nil,nil, 1/24, 1/2 ),
		MenuSlider:new( setToggleZoom,      "Toggle Zoom",      x,290, nil,nil, 1/2,  0   ),
		MenuButton:new( returnToMainMenu,   "Back",             x,360 - 25 - x ),

		MenuText:new( "Settings", { 219 / 255,244 / 255,252 / 255 }, x,40, "left", 0, 2,2 ),
	},

	updateMenu = menu_main.updateMenu,
}


menu_settings = menu

return file